# COVID-19-Tracker
This repository houses code for the visualization of data pertaining to the spread of COVID-19.

## Introduction:
* This code was developed as an activity to keep myself busy, on the first day of the **Total Lockdown** in India, following the rise in the cases of COVID-19 pandemic. This was also, co-incidentally, the first day of the *Indian New Year (Gudhi Padwa / Yugadi)*. The subsequent additions were made later.
* These programmes fetch the latest data pertaining to the spread of the COVID-19 pandemic from web-based data sources and plot/tabulate them.
* The programmes do not manipulate or add any new data. The purpose of these programmes is to visualize the real-time data on a global as well as regional (within India) scale.

## Dependencies:
* This repository relies on the [COVID-19-India_Data](https://github.com/coder-amey/COVID-19-India_Data) repository for visualizing the Indian regional data.
* This repository relies on the [covid-19](https://github.com/datasets/covid-19) repository by the [@datasets](https://github.com/datasets) team for visualizing the global data. I am grateful to the team for regularly compiling, cleaning and updating this dataset from various reliable upstream data sources.
* External Python libraries: pandas, numpy and matplotlib.

## Licensing:
* The upstream datasets are available under the Open Data Commons Public Domain and Dedication License (ODC PDDL) and the MIT License.
* However, this package does not modify data or provide any new data.
* This package provides visualizing tools which can be freely used and modified by anyone. Therefore, this package is available under the MIT License.

## Common Issues:
* The data from the USA are represented using the country name US.
* The data from the UK are represented using the country name United Kingdom.
